*****************************************************************************
* Modulname:	SHRINKVDISP
* Modultype:	OS Display handling
* Dest.Comp.:	HP 49G, ROM C#1.05 and C#1.10
* Language:	sRPL/assembler
* Author:	Detlef Mueller
*
* Interface:	( --> )
*
* Description:	This routine should be called after RECLAIMDISP -- if the
*		current ROM is <= C#1.10, it'll resize ABUFF if neccessary.
*
* Notes:	The routine is save to be executed out of TEMPOB.
*		Algorithm:
*		1) check the ROM version (TBI)
*		2) check if HARDBUFF is <= 131*64 pixel, if so, leave
*		3) shrink HARDBUFF to 131*63 and reset LINENIBS
*		4) call HEIGHTENGOB to set HARDBUFF to 131*64 and implicitly
*		   call disprange (unsupported on the 49) Credits go to
*		   Cyrille de Brebisson for this idea !
*
* To do:	Add ROM version check
*
* Copyright:	(c) 1999 by DM, parts by HP. ALL rights reserved.
*
* $Id: ShrinkV.s 1.4 1999/09/15 22:34:31 Detlef Exp $
*
* $Log: ShrinkV.s $
* Revision 1.4  1999/09/15 22:34:31  Detlef
* Fixed D1 corruption
*
* Revision 1.3	1999/09/14 17:46:57  Detlef
* Moved LINENIBS clearing beyond the test to save time if
* HARDBUFF is of the correct size
*
* Revision 1.2	1999/09/13 20:49:00  Detlef
* Shortened by using GPPushT/F for return
*
* Revision 1.1	1999/09/13 16:15:06  Detlef
* Initial revision
*
*****************************************************************************

::
    ( **

    Check for ROM version here -- if > C#1.10, TRUE else FALSE

    ?SEMI

    ** )

    HARDBUFF

    CODE

LINENIBS	EQU	#00125
LINENIBSg	EQU	#80692

	GOSBVL	=PopASavptr

	LC(5)	=GPPushT/FLp	Prepare return via push T/F
	RSTK=C

	D1=A
	D1=D1+	5		D1->HARDBUFF grob length field
	A=DAT1	A		A[A]=current length

	LCHEX	0088F		Length of a 131*64 grob

	?A<=C	A		not oversized?
	RTNYES			leave and push T

	C=0	W
*				Set LINENIBS to 0.
	D0=(5)	=LINENIBSg
	DAT0=C	X
	D0=(5)	=LINENIBS
	DAT0=C	X

	LCHEX	830003F0086D

	B=A	A		B[A]=length
	A=A-C	A		A[A]=shrink amt.
	DAT1=C	15		length=86D, height=3F, width=83

	CD1EX
	ACEX	A		A[A]->grob (length field), C[A]=shrink amt.
	A=A+B	A		A[A]->past end of grob

	GOVLNG	=MOVERSD	Returns w/ CC, thus push F
    ENDCODE

    ?SEMI

    HARDBUFF ONE HEIGHTENGROB
;
